package camadaDados;

import java.sql.SQLException;
import java.util.GregorianCalendar;
import exceptions.*;
import classesBasicas.Veiculo;

public class RepositorioVeiculo {
	
	private Conexao cnn;
	
	public RepositorioVeiculo(Conexao cnn) {
		super();
		this.cnn = cnn;
	}

	public void inserirVeiculo(Veiculo v) throws SQLException{
		String query = "INSERT INTO SACIVeiculo " +
		"(Placa , Chassi ,Ano ,Cor , Quilometragem ,TipoCombustivel ,Modelo , " +
		"ValorCompra ,ValorSeguro ,DataTrocaOleo , VencimentoSeguro, DataCompra) " +
		"VALUES " +	
		"('" 
			+ v.getPlaca() + "', '" 
			+ v.getChassi() + "', "
			+ v.getAno() + ", '"
			+ v.getCor() + "', "
			+ v.getQuilometragem() + ", '"
			+ v.getTipo_combustivel() + "', '"					
			+ v.getModelo() + "', "
			+ v.getValor_compra() + ", "
			+ v.getValor_seguro() + ", "
			+ this.cnn.stringDataToDate(v.getData_troca_oleo()) + ", "
			+ this.cnn.stringDataToDate(v.getVencimento_seguro())+ ", "
                        + this.cnn.stringDataToDate(v.getDataCompra()) + ")";
		System.out.println(query);
		this.cnn.getStmt().execute(query);
	}
	
	public void descadastrarVeiculo(Veiculo v) throws SQLException{
		this.cnn.getStmt().execute("DELETE FROM SACIVeiculo WHERE Placa = '" +
				v.getPlaca() + "'");
	}
        
        public void descadastrarVeiculo(String placa) throws SQLException{
		this.cnn.getStmt().execute("DELETE FROM SACIVeiculo WHERE Placa = '" +
				placa + "'");
	}
                
	
	public void atualizarVeiculo(Veiculo v) throws SQLException{
		this.cnn.getStmt().execute("UPDATE SACIVeiculo SET " 
				+ "placa = '" + v.getPlaca() + "', " 
				+ "Chassi = " + v.getChassi() + ", "
				+ "Ano = " + v.getAno() + ", "
				+ "Cor = '" + v.getCor() + "', "
				+ "Quilometragem = " + v.getQuilometragem() + ", "
				+ "TipoCombustivel = '" + v.getTipo_combustivel() + "', "				
				+ "Modelo = '" + v.getModelo() + "', "
				+ "ValorCompra = " + v.getValor_compra() + ", "
				+ "ValorSeguro = " + v.getValor_seguro() + ", "
				+ "DataTrocaOleo = " + this.cnn.stringDataToDate(v.getData_troca_oleo()) + ", "
				+ "VencimentoSeguro = " + this.cnn.stringDataToDate(v.getVencimento_seguro()) + ", "
                                + "DataCompra = " + this.cnn.stringDataToDate(v.getDataCompra()) 
				+ " WHERE Placa = '" + v.getPlaca() + "'");
	}
	
	@SuppressWarnings("deprecation")
	public Veiculo buscarVeiculo(String placa) throws NaoEncontrado, SQLException {
		this.cnn.setRset ( 
			this.cnn.getStmt().executeQuery("SELECT Placa , Chassi ,Ano ,Modelo  ,Cor , Quilometragem ,TipoCombustivel  , " +
			"ValorCompra ,ValorSeguro  , TO_CHAR( VencimentoSeguro , 'DD/MM/YYYY') AS VencimentoSeguro , TO_CHAR( DataTrocaOleo , 'DD/MM/YYYY') AS DataTrocaOleo , TO_CHAR( DataCompra , 'DD/MM/YYYY') AS DataCompra " + " FROM SACIVeiculo WHERE placa = '" + placa + "'")
		);
		
		Veiculo v = null;
		
		if(this.cnn.getRset().next()){
			 v = new Veiculo(
                                this.cnn.getRset().getString(1), //placa
                                this.cnn.getRset().getString(2), //chassi
                                Integer.parseInt(this.cnn.getRset().getString(3).substring(0,4)), //ano 
                                this.cnn.getRset().getString(4), //modelo
                                this.cnn.getRset().getString(5), //cor
                                this.cnn.getRset().getDouble(6), //quilometragem
                                this.cnn.getRset().getString(7), //tipo combust�vel
                                this.cnn.getRset().getDouble(8), //valor Compra
                                this.cnn.getRset().getDouble(9), //valor segudo			
                                this.cnn.getRset().getString(10), //vencimento seguro
                                null, //TODO REVER
                                this.cnn.getRset().getString(10), //data troca oleo
                                this.cnn.getRset().getString(11) //data compra
			);
			
		} else {
			throw new NaoEncontrado();
		}
		return v;
	}
	
	public int calcularCusto(String placa) throws SQLException, NaoEncontrado{
		int ret = 0;
		
		this.cnn.setRset ( 
			this.cnn.getStmt().executeQuery("select sum(custo) AS CUSTO from ((select sum( valor) AS CUSTO from sacipecatrocada where placa = " +
					"'"+ placa +"') union (select sum( valorCompra) AS CUSTO  from saciVeiculo where " +
							"placa = '"+ placa +"') union (select sum( valor) AS CUSTO from saciMulta where " +
									"placa = '" + placa + "') union ( select sum( valor) AS CUSTO from saciDefeito where " +
											"placa = '" + placa + "' ) union ( select sum( custo) AS CUSTO from saciAbastece where " +
													"placa = '"+ placa +"') )"));	

			if(this.cnn.getRset().next()){
				 ret = this.cnn.getRset().getInt("CUSTO");
			} else {
				throw new NaoEncontrado();
			}			
		return ret;
	}
	
}